mysite/mysite/blog/urls.py
from . import views
from django.urls import path

urlpatterns = [
    path('', views.PostList.as_view(), name='home'),
    #path('<slug:slug>/', views.PostDetail.as_view(), name='post_detail'),
    path('<slug:slug>/', views.post_detail, name='post_detail')
]

mysite/mysite/mysite/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.http import HttpResponse
urlpatterns = [
    path('admin/', admin.site.urls),
    path('blog/', include('blog.urls')),
    path('todo/',include('tasks.urls')),
    path('gallery/',include('photos.urls')),

]
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL,
                         document_root=settings.STATIC_ROOT)

mysite/mysite/photos/urls.py
from django.urls import path
from . import views

urlpatterns = [    
    path('', views.gallery, name='gallery'),
    path("photo/<str:pk>", views.viewPhoto, name = "photo"),
    path('add/', views.addPhoto, name='add'),
] 

mysite/mysite/tasks/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name = "list"),
    path("update_task/<str:pk>/", views.updateTask, name = "update_task"),
    path("delete/<str:pk>/", views.deleteTask, name = "delete"),

    
]

mysite/mysite/blog/models.py
from django.db import models
from django.contrib.auth.models import User


STATUS = (
    (0,"Draft"),
    (1,"Publish")
)

class Post(models.Model):
    title = models.CharField(max_length=200, unique=True)
    slug = models.SlugField(max_length=200, unique=True)
    author = models.ForeignKey(User, on_delete= models.CASCADE,related_name='blog_posts')
    updated_on = models.DateTimeField(auto_now= True)
    content = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    status = models.IntegerField(choices=STATUS, default=0)

    class Meta:
        ordering = ['-created_on']

    def __str__(self):
        return self.title
class Comment(models.Model):
    post = models.ForeignKey(Post,on_delete=models.CASCADE,related_name='comments')
    name = models.CharField(max_length=80)
    email = models.EmailField()
    body = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    active = models.BooleanField(default=True)

    class Meta:
        ordering = ['created_on']

    def __str__(self):
        return 'Comment {} by {}'.format(self.body, self.name)
        
class Image(models.Model):
    title = models.CharField(max_length=200)
    image = models.ImageField(upload_to='images')

    def __str__(self):
        return self.title

mysite/mysite/photos/models.py
from django.db import models

# Create your models here.
class Category(models.Model):
    name = models.CharField(max_length=100, null=False, blank=False)

    def __str__(self):
        return self.name

class Photo(models.Model):
    category = models.ForeignKey(Category, on_delete=models.SET_NULL, null = True, blank=True)
    image = models.ImageField(null=False, blank=False)
    description = models.TextField()

    def __str__(self):
        return self.description

mysite/mysite/tasks/models.py
from django.db import models

# Create your models here.
class Task(models.Model):
    title = models.CharField(max_length = 200)
    complete = models.BooleanField(default = False)
    created = models.DateTimeField(auto_now_add = True)
    
    def __str__(self):
        return self.title

mysite/mysite/blog/forms.py
from .models import Comment, Image
from django import forms


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ('name', 'email', 'body')
        
class ImageForm(forms.ModelForm):
    """Form for the image model"""
    class Meta:
        model = Image
        fields = ('title', 'image')

mysite/mysite/tasks/forms.py
from django import forms
from django.forms import ModelForm
from .models import *

class TaskForm(forms.ModelForm):
    title= forms.CharField(widget= forms.TextInput(attrs={'placeholder':'Add new task...'}))
    class Meta :
        model = Task
        fields = '__all__'

mysite/mysite/blog/views.py
from django.views import generic
from .models import Post
from .forms import CommentForm, ImageForm
from django.shortcuts import render, get_object_or_404

class PostList(generic.ListView):
    queryset = Post.objects.filter(status=1).order_by('-created_on')
    template_name = 'index.html'
    paginate_by = 3

# class PostDetail(generic.DetailView):
#     model = Post
#     template_name = 'post_detail.html'
#     


def post_detail(request, slug):
    template_name = 'post_detail.html'
    post = get_object_or_404(Post, slug=slug)
    comments = post.comments.filter(active=True)
    new_comment = None
    # Comment posted
    if request.method == 'POST':
        comment_form = CommentForm(data=request.POST)
        if comment_form.is_valid():

            # Create Comment object but don't save to database yet
            new_comment = comment_form.save(commit=False)
            # Assign the current post to the comment
            new_comment.post = post
            # Save the comment to the database
            new_comment.save()
    else:
        comment_form = CommentForm()

    return render(request, template_name, {'post': post,
                                           'comments': comments,
                                           'new_comment': new_comment,
                                           'comment_form': comment_form})

mysite/mysite/photos/views.py
from django.shortcuts import render, redirect
from .models import Category, Photo
# Create your views here.


def gallery(request):
    category = request.GET.get("category")

    if category == None:
        photos = Photo.objects.all()
    else:
        photos = Photo.objects.filter(category__name__contains=category)


    categories = Category.objects.all()
    context = {"categories": categories, "photos": photos}
    return render(request, "photos/gallery.html", context)
    

def viewPhoto(request,pk):
    photo = Photo.objects.get(id = pk)
    return render(request, "photos/photo.html", {'photo': photo})


def addPhoto(request):
    categories = Category.objects.all()

    if request.method == "POST":
        data = request.POST
        image = request.FILES.get("image")
        if data["category"] != 'none':
            category = Category.objects.get(id=data["category"])
        elif data['category_new'] != '':
            category, created = Category.objects.get_or_creat(name = data['category_new'])
        else:
            category = None
        photo = Photo.objects.create(
            category=category,
            description=data["description"],
            image=image
        )

        return redirect("gallery")

    context = {'categories': categories}
    return render(request, 'photos/add.html', context)

mysite/mysite/tasks/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from .models import *
from .forms import *
# Create your views here.

def index(request):
    tasks = Task.objects.all()
    
    form = TaskForm()
    
    if request.method == "POST":
        form =TaskForm(request.POST)
        if form.is_valid():
            form.save()
        return redirect("/")
    
    
    context = {"tasks":tasks, 'form' : form }
    return  render(request, 'tasks/list.html',context)
    
def updateTask(request, pk):
    task = Task.objects.get(id=pk)
    
    form = TaskForm(instance = task)
    
    if request.method == "POST":
        form =TaskForm(request.POST, instance = task)
        if form.is_valid():
            form.save()
            return redirect("/")
        
        
    context = {"form": form}
    
    
    return render(request, "tasks/update_task.html", context)

def deleteTask(request, pk):
    item = Task.objects.get(id = pk)
    
    if request.method == "POST":
        item.delete()
        return redirect("/")
    
    context = {"item" : item}

    return render(request, "tasks/delete.html", context)

mysite/mysite/photos/templates/photos/add.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Gallery</title>
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <style>
        .image-thumbail{
            height : 200px;
            object-fit : cover;
        }




    </style>
</head>
<body class="m-5">
<!-- page content -->
<!-- <div></div> -->
<div class="container ">
    <div class="row justify-content-center ">
        <div class="col-md-4">
            <a href=" {% url 'gallery' %}" class="btn btn-dark my-3"> Go Back</a>
            <div class="card">
                <form method="POST" action="" enctype="multipart/form-data">
                    {% csrf_token %}
                    <div class="form-group m-3">
                        <label>Description</label>
                        <input required name="description" type="text" placeholder="Enter a description" class="form-control">
                    </div>
                    <div class="form-group m-3">
                        <label>Select a category</label>
                        <select name="category" class="form-control">
                            <option value="none"> Select a category...</option>
                            {% for category in categories %}
                            <option value="{{category.id}}">{{ category.name }}</option>
                            {% endfor %}
                        </select>
                    </div>

                    <div class="form-group m-3">
                        <label>Create a new category </label>
                        <input name="category_new" type="text" placeholder="Create a new category" class="form-control">
                    </div>

                    <div class="form-group m-3">
                        <label> Upload image</label>
                        <input required name="image" type="file" class="form-control-file">
                    </div>

                    <button type="submit" class="btn btn-primary m-3"> Submit</button>

                </form>
            </div>
        </div>
    </div>
</div>

</body>

</html>

mysite/mysite/photos/templates/photos/gallery.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Gallery</title>
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <style>
        .image-thumbail{
            height : 200px;
            object-fit : cover;
        }





    </style>
</head>
<body class="m-5">
<!-- page content -->
<!-- <div></div> -->

<div class="container">
    <div class="row">
        <div class="col-md-3">
            <div class="card">
                <div class="card-header">
                    categories
                </div>
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">
                        <a href="{% url 'gallery' %}"> All </a>
                    </li>
                    {% for category in categories %}
                    <li class="list-group-item">
                        <a href="{% url 'gallery' %}?category={{category.name}}"> {{category.name}} </a>
                    </li>
                    {% endfor %}
                    <a href="{% url 'add' %} " class="btn btn-dark btn-block btn-sm m-1"> add picture</a>


                </ul>
            </div>
        </div>


        <div class="col-md-9">
            <div class="row">
                {% for photo in photos %}
                <div class="col-md-4">
                    <div class="card my-2">
                        <img class="image-thumbail"
                             src="{{ photo.image.url }}"
                             alt="Card image cap">
                        <div class="card-body">
                            <small> Catergory : {{photo.category.name}} </small>
                        </div>
                        <a href="{% url 'photo' photo.id %}" class="btn btn-outline-dark btn-sm m-1"> View </a>
                    </div>
                </div>
                {% empty %}
                    <h3>No photos match your category </h3>
                {% endfor %}


            </div>
        </div>
    </div>
</div>
</body>
</html>

mysite/mysite/photos/templates/photos/photo.html
<html>

<head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <title>Add Photo</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">

</head>
<body class="m-5">
<div class="container ">
    <div class="row justify-content-center">
        <div class="col">
            <a href=" {% url 'gallery' %}" class="btn btn-dark my-3"> Go Back</a>
            <div style="height : 90vh;">
                <img style="max-width : 100%;max-height: 100% " src="{{ photo.image.url }}">
                <p> {{ photo.description }}</p>
            </div>
        </div>

    </div>
</div>


</body>
</html>

mysite/mysite/tasks/templates/tasks/delete.html
<p> Are you sure you want to delete "{{item}} ?"</p>

<a href = "{% url 'list' %}" > Cancel </a>

<form method = "POST" action = "">
    {% csrf_token %}
    <input type = "submit" name = "confirm" >
</form>

mysite/mysite/tasks/templates/tasks/list.html
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

<style>

	body{
		background-color: #638CB8;
	}

	input{
		width: 100%;
		padding: 12px 20px;
		margin: 8px 0;
		box-sizing: border-box;
	}

	input::placeholder {
	  color: #d3d3d3;
	}

	.submit{
		background-color: #6BA3E8;
	}

	.center-column{
		width:600px;
		margin: 20px auto;
		padding:20px;
		background-color: #fff;
		border-radius: 3px;
		box-shadow: 6px 2px 30px 0px rgba(0,0,0,0.75);
	}

	.item-row{
		background-color: #906abd;
		margin: 10px;
		padding: 20px;
		border-radius: 3px;
		color: #fff;
		font-size: 16px;
		box-shadow: 0px -1px 10px -4px rgba(0,0,0,0.75);
	}

	.btn-danger{
		background-color: #ffae19;
		border-color: #e59400;
	}

</style>


<div class="center-column">
	<form method ="POST" action = "/" >
		{% csrf_token %}
		{{form.title}}
		<input class="btn btn-info" type = "submit" name = "create Task">
	</form>
	<div class="todo-list">
	{% for task in tasks %}
		<div class="item-row">
		    <a class="btn btn-sm btn-info" href="{% url 'update_task' task.id %}">Update</a>
			<a class="btn btn-sm btn-danger" href="{% url 'delete' task.id %}">Delete</a>
		    
		    {% if task.complete == True %}
		    <strike> {{task}} </strike>
		    {% else %}
		    <span> {{task}}</span>
		    {% endif %}
		</div>
	{% endfor %} 
	</div>
</div>

mysite/mysite/tasks/templates/tasks/update_task.html
<h3> Update Task </h3>


<form method ="POST" action = "" >
    {% csrf_token %}
    
    {{form}}
    <input type = "submit" name = "Update Task">
    
</form>

mysite/mysite/templates/base.html
<!DOCTYPE html>
<html>

    <head>
        <title>My Blog</title>
        <link href="https://fonts.googleapis.com/css?family=Roboto:400,700" rel="stylesheet">
        <meta name="google" content="notranslate" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
            crossorigin="anonymous" />
    </head>

    <body>
        <style>
            body {
            font-family: "Roboto", sans-serif;
            font-size: 17px;
            background-color: #fdfdfd;
        }
        .shadow {
            box-shadow: 0 4px 2px -2px rgba(0, 0, 0, 0.1);
        }
        .btn-danger {
            color: #fff;
            background-color: #f00000;
            border-color: #dc281e;
        }
        .masthead {
            background: #3398E1;
            height: auto;
            padding-bottom: 15px;
            box-shadow: 0 16px 48px #E3E7EB;
            padding-top: 10px;
        }
    </style>

        <!-- Navigation -->
        <nav class="navbar navbar-expand-lg navbar-light bg-light shadow" id="mainNav">
            <div class="container-fluid">
                <a class="navbar-brand" href="{% url 'home' %}">My Blog</a>
                <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive"
                    aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarResponsive">
                    <ul class="navbar-nav ml-auto">
                        <li class="nav-item text-black">
                            <a class="nav-link text-black font-weight-bold" href="#">About</a>
                        </li>
                        <li class="nav-item text-black">
                            <a class="nav-link text-black font-weight-bold" href="#">Policy</a>
                        </li>
                        <li class="nav-item text-black">
                            <a class="nav-link text-black font-weight-bold" href="#">Contact</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
        {% block content %}
        <!-- Content Goes here -->
        {% endblock content %}
        <!-- Footer -->
        <footer class="py-3 bg-grey">
            <p class="m-0 text-dark text-center ">Copyright &copy; Django Central</p>
        </footer>
    </body>
</html>

mysite/mysite/templates/index.html
{% extends "base.html" %} 
{% block content %}
<style>
    body {
        font-family: "Roboto", sans-serif;
        font-size: 18px;
        background-color: #fdfdfd;
    }
    
    .head_text {
        color: white;
    }
    
    .card {
        box-shadow: 0 16px 48px #E3E7EB;
    }
</style>

<header class="masthead">
    <div class="overlay"></div>
    <div class="container">
        <div class="row">
            <div class=" col-md-8 col-md-10 mx-auto">
                <div class="site-heading">
                    <h3 class=" site-heading my-4 mt-3 text-white"> Welcome to my awesome Blog </h3>
                    <p class="text-light">This is my first Django project..! &nbsp
                    </p>
                </div>
            </div>
        </div>
    </div>
</header>
<div class="container">
    <div class="row">
        <!-- Blog Entries Column -->
        <div class="col-md-8 mt-3 left">
            {% for post in post_list %}
            <div class="card mb-4">
                <div class="card-body">
                    <h2 class="card-title">{{ post.title }}</h2>
                    <p class="card-text text-muted h6">{{ "Mazen" }} | {{ post.created_on}} </p>
                    <p class="card-text">{{post.content|slice:":250" }}</p>
                    <a href="{% url 'post_detail' post.slug  %}" class="btn btn-primary">Read More &rarr;</a>
                </div>
            </div>
            {% endfor %}
        </div>
        
        {% block sidebar %} {% include 'sidebar.html' %} {% endblock sidebar %}
    </div>
    {% if is_paginated %}
    <nav aria-label="Page navigation conatiner"></nav>
    <ul class="pagination justify-content-center">
    {% if page_obj.has_previous %}
    <li><a href="?page={{ page_obj.previous_page_number }}" class="page-link">&laquo; &larr;&larr;&larr;PREV  </a></li>
    {% endif %}
    {% if page_obj.has_next %}
    <li><a href="?page={{ page_obj.next_page_number }}" class="page-link"> NEXT &rarr;&rarr;&rarr;&raquo;</a></li>

    {% endif %}
  </ul>
  </nav>
</div>
{% endif %}
</div>
{%endblock%}

mysite/mysite/templates/post_detail.html
{% extends 'base.html' %} {% block content %}
{% load crispy_forms_tags %}

<div class="container">
  <div class="row">
    <div class="col-md-8 card mb-4  mt-3 left  top">
      <div class="card-body">
        <h1>{% block title %} {{ post.title }} {% endblock title %}</h1>
        <p class=" text-muted">{{ post.author }} | {{ post.created_on }}</p>
        <p class="card-text ">{{ post.content | safe }}</p>
      </div>
    </div>
    {% block sidebar %} {% include 'sidebar.html' %} {% endblock sidebar %}

    <div class="col-md-8 card mb-4  mt-3 ">
      <div class="card-body">
        <!-- comments -->
        {% with comments.count as total_comments %}
        <h2>{{ total_comments }} comments</h2>

        <p>
          {% endwith %} {% for comment in comments %}
        </p>

        <div class="comments" style="padding: 10px;">
          <p class="font-weight-bold">
            {{ comment.name }}
            <span class=" text-muted font-weight-normal">
              {{ comment.created_on }}
            </span>
          </p>
          {{ comment.body | linebreaks }}
        </div>

        {% endfor %}
      </div>
    </div>
    <div class="col-md-8 card mb-4  mt-3 ">
      <div class="card-body">
        {% if new_comment %}
        <div class="alert alert-success" role="alert">
          Your comment is awaiting moderation
        </div>
        {% else %}
        <h3>Leave a comment</h3>
        <form method="post" style="margin-top: 1.3em;">
          {{ comment_form | crispy }}
          {% csrf_token %}
          <button type="submit" class="btn btn-primary  btn-lg">Submit</button>
        </form>
        {% endif %}
      </div>
    </div>
  </div>
</div>

{% endblock content %}

mysite/mysite/templates/sidebar.html
{% block sidebar %}
{% load static %}
<style>
        .card{
            box-shadow: 0 16px 48px #E3E7EB;
        }
       
</style>

<!-- Sidebar Widgets Column -->
<div class="col-md-4 float-right ">
<div class="card my-4">
        <h5 class="card-header">About Us</h5>
        <img src="{%static 'images/donky.webp' %}" alt="Hi" srcset="">    
    <div class="card-body">
        <p class="card-text"> Best blog ever!</p>
        <p class="card-text"> This amazing blog is made for people who are interested in everything and espically in Django. Do not click the link below!</p>
        <a href="https://djangocentral.com/building-a-blog-application-with-django"
           class="btn btn-danger">Click me!</a>
           <p class="card-text"> </p>
        <a href="https://djangocentral.com/building-a-blog-application-with-django"
           class="btn btn-danger">Do not click me!</a>
       
    </div>
    
</div>
</div>

{% endblock sidebar %}